# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::LuisRuntime::V3_0
  module Models
    #
    # Represents the prediction of a query.
    #
    class Prediction

      include MsRestAzure

      # @return [String] The query after spell checking. Only set if spell
      # check was enabled and a spelling mistake was found.
      attr_accessor :altered_query

      # @return [String] The name of the top scoring intent.
      attr_accessor :top_intent

      # @return [Hash{String => Intent}] A dictionary representing the intents
      # that fired.
      attr_accessor :intents

      # @return A dictionary representing the entities that fired.
      attr_accessor :entities

      # @return [Sentiment] The result of the sentiment analysis.
      attr_accessor :sentiment


      #
      # Mapper for Prediction class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Prediction',
          type: {
            name: 'Composite',
            class_name: 'Prediction',
            model_properties: {
              altered_query: {
                client_side_validation: true,
                required: false,
                serialized_name: 'alteredQuery',
                type: {
                  name: 'String'
                }
              },
              top_intent: {
                client_side_validation: true,
                required: true,
                serialized_name: 'topIntent',
                type: {
                  name: 'String'
                }
              },
              intents: {
                client_side_validation: true,
                required: true,
                serialized_name: 'intents',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'IntentElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Intent'
                      }
                  }
                }
              },
              entities: {
                client_side_validation: true,
                required: true,
                serialized_name: 'entities',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              sentiment: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sentiment',
                type: {
                  name: 'Composite',
                  class_name: 'Sentiment'
                }
              }
            }
          }
        }
      end
    end
  end
end
